---------------------------------
-----------Turbina-----------
---------------------------------
---------------------------------
--------- @author Classtraktor - Harley ---------
-------- @date  28/06/10 --------
---------------------------------

Turbina = {};

function Turbina.prerequisitesPresent(specializations)
    return true;
end;

function Turbina:load(xmlFile)

local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;

local rotationNodePartRamie = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRamie#index"));
    if rotationNodePartRamie ~= nil then
        self.rotationPartRamie = {};
        self.rotationPartRamie.node = rotationNodePartRamie;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRamie#minRot"));
        self.rotationPartRamie.minRot = {};
        self.rotationPartRamie.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRamie.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRamie.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRamie#maxRot"));
        self.rotationPartRamie.maxRot = {};
        self.rotationPartRamie.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRamie.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRamie.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRamie.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRamie#rotTime"), 2)*1000;
        self.rotationPartRamie.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRamie#touchRotLimit"), 10));
    end; 

local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end; 

local rotationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation3#index"));
    if rotationNode3 ~= nil then
        self.rotation3 = {};
        self.rotation3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#minRot"));
        self.rotation3.minRot = {};
        self.rotation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#maxRot"));
        self.rotation3.maxRot = {};
        self.rotation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#rotTime"), 2)*1000;
        self.rotation3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#touchRotLimit"), 10));
    end; 

	local rotationNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation4#index"));
    if rotationNode4 ~= nil then
        self.rotation4 = {};
        self.rotation4.node = rotationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#minRot"));
        self.rotation4.minRot = {};
        self.rotation4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#maxRot"));
        self.rotation4.maxRot = {};
        self.rotation4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#rotTime"), 2)*1000;
        self.rotation4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#touchRotLimit"), 10));
    end; 
local rotationNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation5#index"));
    if rotationNode5 ~= nil then
        self.rotation5 = {};
        self.rotation5.node = rotationNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#minRot"));
        self.rotation5.minRot = {};
        self.rotation5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#maxRot"));
        self.rotation5.maxRot = {};
        self.rotation5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#rotTime"), 2)*1000;
        self.rotation5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#touchRotLimit"), 10));
    end; 

	local rotationNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation6#index"));
    if rotationNode6 ~= nil then
        self.rotation6 = {};
        self.rotation6.node = rotationNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#minRot"));
        self.rotation6.minRot = {};
        self.rotation6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#maxRot"));
        self.rotation6.maxRot = {};
        self.rotation6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#rotTime"), 2)*1000;
        self.rotation6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#touchRotLimit"), 10));
    end; 
        local rotationNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation11#index"));
    if rotationNode11 ~= nil then
        self.rotation11 = {};
        self.rotation11.node = rotationNode11;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#minRot"));
        self.rotation11.minRot = {};
        self.rotation11.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#maxRot"));
        self.rotation11.maxRot = {};
        self.rotation11.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation11.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#rotTime"), 2)*1000;
        self.rotation11.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#touchRotLimit"), 10));
    end; 
local rotationNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation12#index"));
    if rotationNode12 ~= nil then
        self.rotation12 = {};
        self.rotation12.node = rotationNode12;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#minRot"));
        self.rotation12.minRot = {};
        self.rotation12.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#maxRot"));
        self.rotation12.maxRot = {};
        self.rotation12.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation12.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#rotTime"), 2)*1000;
        self.rotation12.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#touchRotLimit"), 10));
    end; 

    local rotationNode13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation13#index"));
    if rotationNode13 ~= nil then
        self.rotation13 = {};
        self.rotation13.node = rotationNode13;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#minRot"));
        self.rotation13.minRot = {};
        self.rotation13.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#maxRot"));
        self.rotation13.maxRot = {};
        self.rotation13.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation13.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#rotTime"), 2)*1000;
        self.rotation13.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#touchRotLimit"), 10));
    end; 

	local rotationNode14 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation14#index"));
    if rotationNode14 ~= nil then
        self.rotation14 = {};
        self.rotation14.node = rotationNode14;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#minRot"));
        self.rotation14.minRot = {};
        self.rotation14.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#maxRot"));
        self.rotation14.maxRot = {};
        self.rotation14.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation14.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#rotTime"), 2)*1000;
        self.rotation14.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#touchRotLimit"), 10));
    end; 
local rotationNode15 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation15#index"));
    if rotationNode15 ~= nil then
        self.rotation15 = {};
        self.rotation15.node = rotationNode15;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation15#minRot"));
        self.rotation15.minRot = {};
        self.rotation15.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation15.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation15.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation15#maxRot"));
        self.rotation15.maxRot = {};
        self.rotation15.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation15.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation15.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation15.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation15#rotTime"), 2)*1000;
        self.rotation15.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation15#touchRotLimit"), 10));
    end; 
	local rotationNode16 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation16#index"));
    if rotationNode16 ~= nil then
        self.rotation16 = {};
        self.rotation16.node = rotationNode16;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation16#minRot"));
        self.rotation16.minRot = {};
        self.rotation16.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation16.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation16.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation16#maxRot"));
        self.rotation16.maxRot = {};
        self.rotation16.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation16.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation16.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation16.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation16#rotTime"), 2)*1000;
        self.rotation16.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation16#touchRotLimit"), 10));
    end; 

	-- Start Index
	local translationNodeWspornik1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationWspornik1#index"));
    if translationNodeWspornik1 ~= nil then
        self.translationWspornik1 = {};
        self.translationWspornik1.node = translationNodeWspornik1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationWspornik1#minTrans"));
        self.translationWspornik1.minTrans = {};
        self.translationWspornik1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationWspornik1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationWspornik1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationWspornik1#maxTrans"));
        self.translationWspornik1.maxTrans = {};
        self.translationWspornik1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationWspornik1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationWspornik1.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationWspornik1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationWspornik1#transTime"), 2)*1000;
        self.translationWspornik1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationWspornik1#touchTransLimit"), 10);
    end; 

	-- width index
	local translation2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translation2#index"));
    if translation2Node ~= nil then
        self.translation2 = {};
        self.translation2.node = translation2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#minTrans"));
        self.translation2.minTrans = {};
        self.translation2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation2#maxTrans"));
        self.translation2.maxTrans = {};
        self.translation2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translation2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#transTime"), 2)*1000;
        self.translation2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation2#touchTransLimit"), 10);
    end;

	local translation3Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translation3#index"));
    if translation3Node ~= nil then
        self.translation3 = {};
        self.translation3.node = translation3Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#minTrans"));
        self.translation3.minTrans = {};
        self.translation3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translation3#maxTrans"));
        self.translation3.maxTrans = {};
        self.translation3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translation3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translation3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translation3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation3#transTime"), 2)*1000;
        self.translation3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translation3#touchTransLimit"), 10);
	
		
    end;
	
	self.keyB = false;
	self.primo = false;
end;

function Turbina:delete()
end;

function Turbina:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Turbina:keyEvent(unicode, sym, modifier, isDown)
	
	
	
	if sym == Input.KEY_n then
		self.rotationMaxRamie = isDown;	
	end;
	if sym == Input.KEY_m then
		self.rotationMinRamie = isDown;		
	end;	
	-- Codice originale non scommentare
        if sym == Input.KEY_5 then
		self.rotation3Max = isDown;		
	end;
        if sym == Input.KEY_6 then
		self.rotation3Min = isDown;
	end;
        if sym == Input.KEY_7 then
		self.rotation4Max = isDown;		
	end;
        if sym == Input.KEY_8 then
		self.rotation4Min = isDown;
	end;
	-- Codice originale    
	if sym == Input.KEY_k then
		self.rotation2Max = isDown;		
	end;
	if sym == Input.KEY_l then
		self.rotation2Min = isDown;		
	end;
        if sym == Input.KEY_o then
		self.rotation5Max = isDown;		
	end;
        if sym == Input.KEY_u then
		self.rotation5Min = isDown;
	end;
        if sym == Input.KEY_t then
		self.rotation6Max = isDown;		
	end;
        if sym == Input.KEY_g then
		self.rotation6Min = isDown;
	end;

	
	 if sym == Input.KEY_KP_9 then
		self.translationMax = isDown;
	end;
	if sym == Input.KEY_KP_6 then
		self.translationMin = isDown;
	end;
	

	if sym == Input.KEY_KP_0 then
		self.rotation11Max = isDown;	
	end;
	if sym == Input.KEY_KP_1 then
		self.rotation11Min = isDown;		
	end;	
	
        if sym == Input.KEY_KP_8 then
		self.rotation12Max = isDown;		
	end;
        if sym == Input.KEY_KP_5 then
		self.rotation12Min = isDown;
	end;
        if sym == Input.KEY_KP7 then
		self.rotation13Max = isDown;		
	end;
        if sym == Input.KEY_KP_4 then
		self.rotation13Min = isDown;
	end;
	
	if sym == Input.KEY_r then
		self.rotation14Max = isDown;		
	end;
	if sym == Input.KEY_v then
		self.rotation14Min = isDown;		
	end;
        if sym == Input.KEY_KP_2 then
		self.rotation15Max = isDown;		
	end;
        if sym == Input.KEY_KP_3 then
		self.rotation15Min = isDown;
	end;
        if sym == Input.KEY_y then
		self.rotation16Max = isDown;		
	end;
        if sym == Input.KEY_z then
		self.rotation16Min = isDown;
	end;


	--if sym == Input.KEY_b then
	--	print("KEY_b");
	--	if self.keyB then
	--		self.translationMin = true;
	--		self.translation2Min = true;
	--		self.primo = true;
	--	else
	--		self.keyB = true;
	--		self.translationMax = true;
	--		self.translation2Max = true;
	--		self.primo = true;
	--	end;
	--end;
	
end;

function Turbina:update(dt)
	
local doTranslate = self.translationMax or self.translationMin 
	if self.translationPart ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax); 
		setTranslation(self.translationPart.node, unpack(newTrans)); 
	end; 

	if self.translationWspornik1 ~= nil then 
		local x, y, z = getTranslation(self.translationWspornik1.node);
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationWspornik1.maxTrans, self.translationWspornik1.minTrans, 3, self.translationWspornik1.transTime, dt, not self.translationMax); 
		setTranslation(self.translationWspornik1.node, unpack(newTrans)); 
	end;
	
	if self.translation2 ~= nil then
		local x, y, z = getTranslation(self.translation2.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation2.maxTrans, self.translation2.minTrans, 3, self.translation2.transTime, dt, not self.translation2Max);
		setTranslation(self.translation2.node, unpack(newTrans));
	end;
	
	local doRotate = self.rotationMaxRamie or self.rotationMinRamie
	if self.rotationPartRamie ~= nil and doRotate then
		local x, y, z = getRotation(self.rotationPartRamie.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRamie.maxRot, self.rotationPartRamie.minRot, 3, self.rotationPartRamie.rotTime, dt, not self.rotationMaxRamie);
		setRotation(self.rotationPartRamie.node, unpack(newRot));
	end;

	local doRotate = self.rotation2Max or self.rotation2Min
	if self.rotation2 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
		setRotation(self.rotation2.node, unpack(newRot));
	end;

	local doRotate = self.rotation3Max or self.rotation3Min
	if self.rotation3 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation3.maxRot, self.rotation3.minRot, 3, self.rotation3.rotTime, dt, not self.rotation3Max);
		setRotation(self.rotation3.node, unpack(newRot));
	end;

	local doRotate = self.rotation4Max or self.rotation4Min
	if self.rotation4 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation4.maxRot, self.rotation4.minRot, 3, self.rotation4.rotTime, dt, not self.rotation4Max);
		setRotation(self.rotation4.node, unpack(newRot));
	end;

	local doRotate = self.rotation5Max or self.rotation5Min
	if self.rotation5 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation5.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation5.maxRot, self.rotation5.minRot, 3, self.rotation5.rotTime, dt, not self.rotation5Max);
		setRotation(self.rotation5.node, unpack(newRot));
	end;

	local doRotate = self.rotation6Max or self.rotation6Min
	if self.rotation6 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation6.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation6.maxRot, self.rotation6.minRot, 3, self.rotation6.rotTime, dt, not self.rotation6Max);
		setRotation(self.rotation6.node, unpack(newRot));
	end;
        local doRotate = self.rotation11Max or self.rotation11Min
	if self.rotation11 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation11.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation11.maxRot, self.rotation11.minRot, 3, self.rotation11.rotTime, dt, not self.rotation11Max);
		setRotation(self.rotation11.node, unpack(newRot));
	end;
local doRotate = self.rotation12Max or self.rotation12Min
	if self.rotation12 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation12.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation12.maxRot, self.rotation12.minRot, 3, self.rotation12.rotTime, dt, not self.rotation12Max);
		setRotation(self.rotation12.node, unpack(newRot));
	end;

	local doRotate = self.rotation13Max or self.rotation13Min
	if self.rotation13 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation13.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation13.maxRot, self.rotation13.minRot, 3, self.rotation13.rotTime, dt, not self.rotation13Max);
		setRotation(self.rotation13.node, unpack(newRot));
	end;

	local doRotate = self.rotation14Max or self.rotation14Min
	if self.rotation14 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation14.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation14.maxRot, self.rotation14.minRot, 3, self.rotation14.rotTime, dt, not self.rotation14Max);
		setRotation(self.rotation14.node, unpack(newRot));
	end;

	local doRotate = self.rotation15Max or self.rotation15Min
	if self.rotation15 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation15.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation15.maxRot, self.rotation15.minRot, 3, self.rotation15.rotTime, dt, not self.rotation15Max);
		setRotation(self.rotation15.node, unpack(newRot));
	end;

	local doRotate = self.rotation16Max or self.rotation16Min
	if self.rotation16 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotation16.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotation16.maxRot, self.rotation16.minRot, 3, self.rotation16.rotTime, dt, not self.rotation16Max);
		setRotation(self.rotation16.node, unpack(newRot));
	end;


	-- Codice originale non scommentare
	--local doTranslate = self.translationMax or self.translationMin
	--if self.translationWspornik1 ~= nil and doTranslate then 
	--	local x, y, z = getTranslation(self.translationWspornik1.node);
	--	print("translat1 x, y, z:"..x..","..y..","..z);
	--	local trans = {x,y,z}; 
	--	local newTrans = Utils.getMovedLimitedValues(trans, self.translationWspornik1.maxTrans, self.translationWspornik1.minTrans, 3, self.translationWspornik1.transTime, dt, not self.translationMax); 
	--	setTranslation(self.translationWspornik1.node, unpack(newTrans)); 
	--end;
	--local doTranslate = self.translationMax or self.translationMin
	--if self.translation2 ~= nil and doTranslate then 
	--	local x, y, z = getTranslation(self.translation2.node); 
	--	local trans = {x,y,z}; 
	--	local newTrans = Utils.getMovedLimitedValues(trans, self.translation2.maxTrans, self.translation2.minTrans, 3, self.translation2.transTime, dt, not self.translationMax); 
	--	setTranslation(self.translation2.node, unpack(newTrans)); 
	--end;
	-- Codice originale

	local doTranslate = self.translationMax or self.translationMin
	if self.translation3 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translation3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translation3.maxTrans, self.translation3.minTrans, 3, self.translation3.transTime, dt, not self.translationMax); 
		setTranslation(self.translation3.node, unpack(newTrans)); 
	end;
end;

function Turbina:draw()
end;

function Turbina:onAttach(attacherVehicle)
end;

function Turbina:onDetach()
end;

function Turbina:onEnter()
end;

function Turbina:onLeave()
end;

function Turbina:onActivate()
end;

function Turbina:onDeactivate()
end;

function Turbina:onDeactivateSounds()
end;

function Turbina:addContactReports()
end;

function Turbina:removeContactReports()
end;

function Turbina:groundContactReport(objectId, otherObjectId, isStart, normalForce, tangentialForce)

end;

function Turbina:validateAttacherJoint(implement, jointDesc, dt)
end;